org.vishia.gral.swt

## Class SwtHorizontalSelector

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess
  - - org.vishia.gral.widget.GralHorizontalSelector.GraphicImplAccess
    - - org.vishia.gral.swt.SwtHorizontalSelector

- All Implemented Interfaces:
    GralWidgImpl_ifc

      public class SwtHorizontalSelector
      extends GralHorizontalSelector.GraphicImplAccess
      implements GralWidgImpl_ifc

  This class is a selector in one line. You can set the cursor into the field.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private org.eclipse.swt.graphics.Font` | `fontText`
    `(package private) org.eclipse.swt.events.MouseListener` | `mouseListener`
    `(package private) org.eclipse.swt.events.PaintListener` | `paintListener`
    `private SwtWidgetHelper` | `swtWdgW` It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.
    `static int` | `version` Version, history and copyright/copyleft.

    - ### Fields inherited from class org.vishia.gral.widget.GralHorizontalSelector.GraphicImplAccess

      `outer`

    - ### Fields inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `chgBitsDerived, chgColorBack, chgColorLine, chgColorText, chgEditable, chgFloat, chgFocus, chgFont, chgIntg, chgInvisible, chgObjects, chgPos, chgText, chgVisible, chgVisibleInfo, pixBounds, wdgimpl, widgg`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SwtHorizontalSelector(SwtMng mng, GralHorizontalSelector<?> wdgGral)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralRectangle` | `getPixelPositionSize()`
    `java.lang.Object` | `getWidgetImplementation()` Returns the implementation class of the widget.
    `protected void` | `mouseDown(org.eclipse.swt.events.MouseEvent e)`
    `void` | `mouseUp(org.eclipse.swt.events.MouseEvent e)`
    `protected void` | `paintControl(org.eclipse.swt.widgets.Canvas swt, org.eclipse.swt.events.PaintEvent e)`
    `void` | `removeWidgetImplementation()` Removes the graphical widget in the graphic.
    `void` | `repaintGthread()` This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
    `void` | `setBoundsPixel(int x, int y, int dx, int dy)`
    `boolean` | `setFocusGThread()` Sets the focus to the widget.
    `void` | `setVisibleGThread(boolean bVisible)` Sets the implementation widget(s) visible state.

    - ### Methods inherited from class org.vishia.gral.widget.GralHorizontalSelector.GraphicImplAccess

      `actItem, calcLeftTab, clearDstItem, execAfterCreationImplWidget, findTab, items, nrItem, nrLeftTab, nrofTabs, removeDstItem, setDstToActItem, tab`

    - ### Methods inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `acknChanged, actionShow, dyda, getActionChange, getChanged, gralWidgetFromImplData, setDragEnable, setDropEnable, setFocused, setTextChanged, setVisibleState, XXXfocusGained`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### version

          public static final int version

      Version, history and copyright/copyleft.
      - 2013-06-18 Hartmut created, new idea.
      Copyright/Copyleft:
      For this source the LGPL Lesser General Public License, published by the Free Software Foundation is valid. It means:
      1. You can use this source without any restriction for any desired purpose.
      2. You can redistribute copies of this source to everybody.
      3. Every user of this source, also the user of redistribute copies with or without payment, must accept this license for further using.
      4. But the LPGL is not appropriate for a whole software product, if this source is only a part of them. It means, the user must publish this part of source, but doesn't need to publish the whole source of the own product.
      5. You can study and modify (improve) this source for own using or for redistribution, but you have to license the modified sources likewise under this LGPL Lesser General Public License. You mustn't delete this Copyright/Copyleft inscription in this source file.
      If you intent to use this source without publishing its usage, you can get a second license subscribing a special contract with the author.
      See Also:
        Constant Field Values

    - #### swtWdgW

          private final SwtWidgetHelper swtWdgW

      It contains the association to the swt widget (Control) and the `SwtMng` and implements some methods of `GralWidgImpl_ifc` which are delegate from this.

    - #### fontText

          private org.eclipse.swt.graphics.Font fontText

    - #### paintListener

          org.eclipse.swt.events.PaintListener paintListener

    - #### mouseListener

          org.eclipse.swt.events.MouseListener mouseListener

  - ### Constructor Detail

    - #### SwtHorizontalSelector

          public SwtHorizontalSelector(SwtMng mng,
                                       GralHorizontalSelector<?> wdgGral)

  - ### Method Detail

    - #### repaintGthread

          public void repaintGthread()

      Description copied from interface: `GralWidgImpl_ifc`
      This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
      Implementation hints: In SWT it should call redraw().
      It is possible that the widget consists of more as one graphical widget, then all of it should be redrawn. It is possible that some data are set in another thread, they should be applied to the widgets firstly. It is possible that the widget is removed though a repaintGthread-order is pending from the time before deleting, for example if the graphic layout is changed.
      See `#repaintRequ`
      Specified by:
        `repaintGthread` in interface `GralWidgImpl_ifc`

    - #### getWidgetImplementation

          public java.lang.Object getWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Returns the implementation class of the widget. If the widget has more as one implementation widgets, this method returns one of the widgets, usual the first important one respectively that widget which represents the implementation layer. A widget of the implementation layer is a SWT.control or a `Component`.
      If more as one widget are part of the GralWidget, use the special `GralWidget._wdgImpl` class which should contain the references to that implementation widgets.
      Specified by:
        `getWidgetImplementation` in interface `GralWidgImpl_ifc`

    - #### setFocusGThread

          public boolean setFocusGThread()

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the focus to the widget. See `GralMng_ifc#setFocus(GralWidget)`.
      Specified by:
        `setFocusGThread` in interface `GralWidgImpl_ifc`
      Returns:
        true if it has the focus after this operation. false on any error.

    - #### setVisibleGThread

          public void setVisibleGThread(boolean bVisible)

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the implementation widget(s) visible state. The widgets are really invisible, or they are visible in principle, but they can be covered by other windows or clipping. This method should set the `GralWidget.bVisibleState` too. Therewith it is able to quest `GralWidget.isVisible()` in any thread.
      Specified by:
        `setVisibleGThread` in interface `GralWidgImpl_ifc`
      Parameters:
        `bVisible` - true then the widget should be visible, false it is set to invisible.

    - #### removeWidgetImplementation

          public void removeWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Removes the graphical widget in the graphic.
      Specified by:
        `removeWidgetImplementation` in interface `GralWidgImpl_ifc`

    - #### setBoundsPixel

          public void setBoundsPixel(int x,
                                     int y,
                                     int dx,
                                     int dy)

      Specified by:
        `setBoundsPixel` in interface `GralWidgImpl_ifc`

    - #### getPixelPositionSize

          public GralRectangle getPixelPositionSize()

      Specified by:
        `getPixelPositionSize` in interface `GralWidgImpl_ifc`

    - #### paintControl

          protected void paintControl(org.eclipse.swt.widgets.Canvas swt,
                                      org.eclipse.swt.events.PaintEvent e)

    - #### mouseDown

          protected void mouseDown(org.eclipse.swt.events.MouseEvent e)

    - #### mouseUp

          public void mouseUp(org.eclipse.swt.events.MouseEvent e)